POI 2001 Goldmine 线段树 扫描线

题目链接

http://www.acm.cs.ecnu.edu.cn/problem.php?problemid=1350

http://main.edu.pl/en/archive/oi/8/kop

求平面n个点(n<=15000),用一个 长宽为 s w的矩阵去套,能套到的最多的点数,在边上的点也算

其实跟之前矩形嵌套求面积类似 (POJ的atlantic)用类似扫描线的做法,把点当做边 (y 到  y值+w),插入线段树,这样就维护了y方向,x方向就用类似队列维护,

在距离大于s的时候,就弹出前面的(即线段树移除那条边),一边添加当前边

维护一个值,看从前扫到后,边层数累积的最多的时候即可。

一开始还以为要维护覆盖值,后来发现没用,直接一个d维护积累层数即可。

一开始输入那里没写好EOF,RE了几次,不知道什么原因,改完之后1A

#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#define lson rt<<1,l,mid
#define rson rt<<1|1,mid+1,r
using namespace std;
const int N = 100020;
//int cover[N<<2];
int flag[N<<2];
int d[N<<2];
int s,w,n,maxn;
struct node{
    int x,y;
    bool operator < (const node& rhs ) const{
        if (x==rhs.x) return y<rhs.y;
        return x<rhs.x;
    }
}point[15010];
bool input()
{
    maxn=0;
    if (scanf("%d%d",&s,&w)==EOF) return false;
    scanf("%d",&n);
    for (int i=1;i<=n;i++){
        scanf("%d%d",&point[i].x,&point[i].y);
        point[i].x+=30000;
        point[i].y+=30000;
        maxn=max(maxn,point[i].y);
    }
    maxn+=w+10;
    return true;
}
void build(int rt,int l,int r)
{
    //cover[rt]=0;
    flag[rt]=0;
    d[rt]=0;
    if (l>=r) return;
    int mid=(l+r)>>1;
    build(lson);
    build(rson);
}
void pushdown(int rt,int l,int r)
{
    if (flag[rt]==0) return;
    int mid=(l+r)>>1;
    //cover[rt<<1]+=flag[rt]*(mid-l+1);
    //cover[rt<<1|1]+=flag[rt]*(r-mid);
    d[rt<<1]+=flag[rt];
    d[rt<<1|1]+=flag[rt];
    flag[rt<<1]+=flag[rt];
    flag[rt<<1|1]+=flag[rt];
    flag[rt]=0;
}
void up(int rt)
{
    //cover[rt]=cover[rt<<1]+cover[rt<<1|1];
    d[rt]=max(d[rt<<1],d[rt<<1|1]);
}
void remove(int L,int R,int rt,int l,int r)
{
    if (L<=l && r<=R){
        //cover[rt]-=(r-l+1);
        d[rt]--;
        flag[rt]+=-1;
        return;
    }
    pushdown(rt,l,r);
    int mid=(l+r)>>1;
    if (L<=mid) remove(L,R,lson);
    if (R>mid) remove(L,R,rson);
    up(rt);
}
void inserts(int L,int R,int rt,int l,int r)
{
    if (L<=l && r<=R){
        //cover[rt]+=(r-l+1);
        d[rt]++;
        flag[rt]+=1;
        return ;
    }
    pushdown(rt,l,r);
    int mid=(l+r)>>1;
    if (L<=mid) inserts(L,R,lson);
    if (R>mid) inserts(L,R,rson);
    up(rt);
}
int main()
{
    while (input()){
    sort(point+1,point+1+n);
    build(1,0,maxn);
    int pre=1;
    int ans=0;
    for (int i=1;i<=n;i++){
        //cout<<i<<endl;
        while (point[pre].x+s<point[i].x){
            remove(point[pre].y,point[pre].y+w,1,0,maxn);
            pre++;
        }
        inserts(point[i].y,point[i].y+w,1,0,maxn);
        ans=max(ans,d[1]);
      }
    printf("%d\n",ans);
   }
}

  

时间: 2024-10-11 03:30:18

POI 2001 Goldmine 线段树 扫描线的相关文章

[POI 2001+2014acm上海邀请赛]Gold Mine/Beam Cannon 线段树+扫描线

Description Byteman, one of the most deserving employee of The Goldmine of Byteland, is about to retire by the end of the year. The Goldmine management would like to reward him in acknowledgment of his conscientious work. As a reward Byteman may rece

【BZOJ】1382: [Baltic2001]Mars Maps (线段树+扫描线)

1382: [Baltic2001]Mars Maps Time Limit: 5 Sec  Memory Limit: 64 MB Description 给出N个矩形,N<=10000.其坐标不超过10^9.求其面积并 Input 先给出一个数字N,代表有N个矩形. 接下来N行,每行四个数,代表矩形的坐标. Output 输出面积并 Sample Input 2 10 10 20 20 15 15 25 30 Sample Output 225 本以为是傻逼题,没想到不容易啊- 线段树+扫描

BZOJ 4059 Cerc2012 Non-boring sequences 线段树+扫描线

题目大意:定义一个序列为[不无聊的]当且仅当这个序列的任意一个区间都存在一个数只出现过一次,给定一个序列,要求判断这个序列是否是[不无聊的] 定义lasti表示第i个元素上一次出现的位置(第一次出现则为0),nexti表示第i个元素下一次出现的位置(最后一次出现则为n+1),那么这个元素能成为某个区间仅出现一次的数,当且仅当这个区间的左端点在[lasti+1,i]之间,右端点在[i,nexti?1]之间 我们可以将区间的左右端点放在二维平面上,那么一个元素产生的贡献是一个矩形,我们要确定的是所有

HDU 4419 Colourful Rectangle --离散化+线段树扫描线

题意: 有三种颜色的矩形n个,不同颜色的矩形重叠会生成不同的颜色,总共有R,G,B,RG,RB,GB,RGB 7种颜色,问7种颜色每种颜色的面积. 解法: 很容易想到线段树扫描线求矩形面积并,但是如何维护每种颜色的长度着实让我伤透了脑筋.后来看了一位朋友的题解,才幡然醒悟. 开始想到了用二进制表示颜色,R用001表示,G用010表示,B用100表示.那么就可以用十进制1~7表示7种不同颜色了. 维护 cov[rt][1~3] 表示此区间内3种原色各有多少个, Len[rt][i]表示每种颜色的长

sgu316Kalevich Strikes Back(线段树+扫描线)

做法:总体想法是求出一个矩形的面积以及它所包含的矩形,然后用自己的面积减掉所包含的.主要问题是怎样求解它所包含的矩形. 因为是没有相交点的,可以利用扫描线的方法去做,类似染色,当前段如果是x色,也就是第x个矩形,那么再把他染成y颜色时,说明x包含y,而当扫到y的上边时,这一段又恢复到x色.标记一下被包含的矩形,记录所包含的矩形. 因为会有恢复染色操作,up需要时时更新,左儿子和右儿子一样颜色时就可以合并为一段. 1 ; 2 } 3 void down(int w) 4 { 5 if(s[w]!=

hdu1255 覆盖的面积 线段树-扫描线

矩形面积并 线段树-扫描线裸题 1 #include<stdio.h> 2 #include<string.h> 3 #include<algorithm> 4 #include<math.h> 5 using namespace std; 6 const int maxm=2e3+5; 7 const double eps=1e-5; 8 9 struct seg{ 10 double x,y1,y2; 11 int c; 12 bool operator

线段树+扫描线 HDOJ 5091 Beam Cannon

题目传送门 1 /* 2 题意:给出若干个点的坐标,用一个矩形去覆盖,问最多能覆盖几个点 3 线段树+扫描线:思路是先建一棵以[y, y + h]的树,左右儿子[x, x + w] 4 以这棵树为范围,从左到右扫描,更新点数,x的+1, x+w的-1(超过矩形范围) 5 ans = 每次更新时所覆盖点数的最大值 6 */ 7 #include <cstdio> 8 #include <algorithm> 9 #include <iostream> 10 #includ

POJ 3277 City Horizon(线段树+扫描线+离散化)

题目地址:POJ 3277 水题..稍微处理一下然后用求面积并的方法求即可. 代码如下: #include <iostream> #include <cstdio> #include <string> #include <cstring> #include <stdlib.h> #include <math.h> #include <ctype.h> #include <queue> #include <

hdu1542 Atlantis (线段树+扫描线+离散化)

Atlantis Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 9032    Accepted Submission(s): 3873 Problem Description There are several ancient Greek texts that contain descriptions of the fabled i